<template>
  <b-modal
    id="create-new-issue-modal"
    title="Create new issue"
    size="lg"
  >
    <b-form @submit="onSubmit">
      <b-form-group
        id="input-group-project"
        label="Project"
        label-for="input-project"
      >
        <b-form-select 
          id="input-project"
          v-model="form.project_id"
          :options="input_list_projects"
          class="subtle-shadow"
        ></b-form-select>
      </b-form-group>

      <b-form-group
        id="input-group-title"
        label="Title"
        label-for="input-titlee"
      >
        <b-form-input
          id="input-title"
          v-model="form.title"
          required
          placeholder=""
          class="subtle-shadow"
        ></b-form-input>
      </b-form-group>

      <b-form-group 
        id="input-group-description"
        label="Description"
        label-for="input-description"
      >
        <b-form-textarea
          id="input-description"
          v-model="form.description"
          required
          placeholder=""
          class="subtle-shadow"
          rows=5
        ></b-form-textarea>
      </b-form-group>
    </b-form>

    <template v-slot:modal-footer="{ ok, cancel }">
      <b-button variant="primary" @click="onSubmit()">
        Create
      </b-button>
      <b-button variant="danger" @click="cancel()">
        Cancel
      </b-button>
    </template>
  </b-modal>
</template>

<script>
import { mapState } from 'vuex'

function transform_projects_to_input_items(projects) {
  let items = [];

  for (let i = 0; i < projects.length; i++) {
    const project = projects[i];
    items.push({ value: project.id, text: project.name });
  }

  return items;
}

export default {
  name: 'CreateNewIssueModal',
  data() {
    return {
      empty_form: {
        project_id: null,
        title: 'A new issue',
        description: 'This is the description field for this issue, and it should allow fancy formatting'
      },
      form: {}
    }
  },
  computed: mapState({
    projects: state => state.issues.projects.all,
    input_list_projects(state) {
      return transform_projects_to_input_items(state.issues.projects.all)
    }
  }),
  methods: {
    onSubmit(evt) {
      if (evt) {
        evt.preventDefault();
      }

      let issue = this.form;

      this.$store.dispatch('issues/issues/createNew', { issue })
        .then((resp) => {
          this.$bvModal.hide('create-new-issue-modal');
          this.$router.push({ name: 'IssuesProjectViewIssue', params: { key: resp.key } })
        })
        .catch(error => {
          this.$bvToast.toast(error, {
            title: 'Failed to create new issue',
            toaster: 'b-toaster-top-center',
            solid: true,
            appendToast: false
          });
        })
    }
  },
  created() {
    this.$store.dispatch('issues/projects/getAll');
    this.form = this.empty_form;
  }
}
</script>

<style scoped lang="scss">
</style>
